
/*******************************************************************
   Szm prm mivoltnak megllaptsa, prmtnyezk meghatrozsa
*******************************************************************/
var PrimeFactors;
var Exponents;
var length;



function isPrime(x) {
   var i = 3, sqrt_x = Math.round(Math.sqrt(x));

   if (x == 2) return true;
   if (x % 2 == 0) return 0;
   while (x % i != 0 && i <= sqrt_x) {
      i += 2;
   }
   return (i <= sqrt_x ? false : true);
}



function Factorize(x) {
   var i = 1, k = 1, base, sqroot;
   var finished = false;

   base = x;
   sqroot = x;
   do {
      ++i;
      k = 1;
      if (base % i == 0) {
         PrimeFactors[length] = i;
         length++;
      }
      while (base % i == 0) {
         Exponents[length - 1] = k++;
         base /= i;
         sqroot = Math.round(Math.sqrt(base));
      }
      if (i > sqroot) {
         finished = true;
      }
   } while (!finished);
   if (base != 1) {
      PrimeFactors[length] = base;
      Exponents[length] = 1;
      length++;
   }
}


function PrintResult(x) {
   var k, toCheck, exponent;
   for (k = 0; k < length; k++) {
      if (Exponents[k] == 1) {
         top.frames[2].document.write(PrimeFactors[k]);
      } else {
         top.frames[2].document.write(PrimeFactors[k] + "<sup>" + Exponents[k] + "<\/sup>");
      }
      if (k < length - 1) {
         top.frames[2].document.write("&nbsp;<sup><b>.</b></sup>&nbsp;");
      }
   }
}



function PrimeTest(x, test) {
   if (x == "") {
      alert("Valamennyi mezt ki kell tlteni!");
   } else if (x <= 0) {
      alert("Minden meznek pozitv egsznek kell lennie!");
   } else {
      PrimeFactors = new Array();
      Exponents = new Array();
      length = 0;
      top.frames[2].document.write("<head><style type='text/css'>td { font-family: monospace } body {font-family: sans-serif }<\/style><\/head><body>");
      if (isPrime(x)) {
         top.frames[2].document.write("Az <b>x = " + x + "<\/b> szm prm.");
      } else {
         top.frames[2].document.write("Az <b>x = " + x + "<\/b> szm nem prm.");
         if (test) {
            top.frames[2].document.write("<p>Prmtnyezs felbontsa:<p style='margin-left:4%'>");
            top.frames[2].document.write("<code><b>");
            Factorize(x);
            PrintResult(x);
            top.frames[2].document.write("<\/b><\/code>");
         }
      }
      top.frames[2].document.write("<\/body>");
      top.frames[2].document.close();
   }
}
